import java.io.BufferedReader;
import java.io.FileReader;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.FileNotFoundException;
import java.io.IOException;

import java.util.Vector;
import java.util.Enumeration;

public class PriorityStatus
{

	private boolean bFileNotFound;

	private PriorityStatusForm psfForm;
	
	private PriorityDriverParameters pdpValues;
	
	public PriorityStatus()
	{
		this.bFileNotFound = false;
		
		this.pdpValues = new PriorityDriverParameters(); 
		this.psfForm = new PriorityStatusForm(this.pdpValues, this);
		
		this.readDriverInfo();
		this.psfForm.updateForm(this.bFileNotFound);
	}

	private void readDriverInfo()
	{
		FileReader fr = null;
		this.bFileNotFound = false;
		try
		{
			fr = new FileReader("priority.txt");
			//fr = new FileReader("/proc/net/madwifi/ath0/priority");
		}
		catch(FileNotFoundException e)
		{
			this.bFileNotFound = true;
		}
		if(!this.bFileNotFound)
		{
			try
			{
				BufferedReader br = new BufferedReader(fr);
				
				br.readLine(); //ignore the number of entries
				
				this.pdpValues.removeAllPriorityMAC();
				
				for(String sLine = br.readLine(); sLine != null; sLine = br.readLine())
					this.pdpValues.addPriorityMAC(sLine);

				br.close();
				fr.close();
			}
			catch (IOException e) 
			{	
				System.out.println("Exception in reading File!!!");
				e.printStackTrace();
			}
		}
		
	}

	public void writeDriverInfo()
	{
		FileWriter fw = null;
		boolean bFileProblem = false;
		try
		{
			fw = new FileWriter("priority.txt");
			//fw = new FileWriter("/proc/net/madwifi/ath0/priority");
		}
		catch(IOException e)
		{
			bFileProblem = true;
		}
		if(!bFileProblem)
		{
			try
			{
				BufferedWriter bw = new BufferedWriter(fw);
				
				Vector vPriorityEntries = this.pdpValues.getAllPriorityMAC(); 
				
				String strSize = String.valueOf(vPriorityEntries.size());
				bw.write(strSize, 0, strSize.length());
				bw.newLine();
				
				Enumeration enumVar = vPriorityEntries.elements();
				while(enumVar.hasMoreElements())
				{
					Vector vPriorityEntry = (Vector)enumVar.nextElement();
					String strMac = (String)vPriorityEntry.get(0);
					bw.write(strMac, 0, strMac.length());
					bw.newLine();
				}
				
				bw.close();
				fw.close();
			}
			catch (IOException e) 
			{	
				System.out.println("Exception in writing File!!!");
				e.printStackTrace();
			}
		}	
	}

	public static void main(String[] args)
	{
		new PriorityStatus();
	}

}
